<template>
  <div class="airportInfo scroll-y">
    <div class="wrap">
      <Minheader
        :is-auth="true"
        :is-statuser="true"
        powerData="agreement_addition"
        @addForm="addForm"
      >
        <template #header>
          <div class="status flex-wrap">
            <div class="manageTitle">协议管理</div>
          </div>
        </template></Minheader
      >
      <div class="app-containers">
        <DataTable
          :tableHeader="tableCols"
          :tableData="tableData"
          :tableBtnGroup="tableBtnGroup"
          :tableProperty="{ rowKey: 'ID' }"
          @btnClick="btnClick"
        />
      </div>
      <Dialog
        width="508px"
        :flag="flag"
        :type="type"
        :msgTitle="msgTitle"
        @resetForm="resetForm"
        @delRest="delRest"
        @submitForm="submitForm"
        @delRemove="delRemove"
      >
        <div class="diacont">
          <el-form
            :model="tableForm"
            :rules="formRules"
            ref="protocolManagement"
          >
            <el-row :gutter="24">
              <el-col>
                <el-form-item
                  label="协议名称"
                  size="default"
                  prop="protocolName"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.protocolName"
                    placeholder="请输入协议名称"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item
                  label="类名"
                  size="default"
                  prop="className"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    type="textarea"
                    v-model="tableForm.className"
                    placeholder="请输入类名"
                  />
                </el-form-item>
              </el-col>
              <!-- <el-col>
                <el-form-item label="协议类型" size="default">
                  <el-input
                    v-model="tableForm.protocolType"
                    placeholder="请输入协议类型"
                  />
                </el-form-item>
              </el-col> -->
              <el-col>
                <el-form-item
                  label="读方法名"
                  size="default"
                  prop="rmethodName"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.rmethodName"
                    placeholder="请输入读方法名"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item
                  label="写方法名"
                  size="default"
                  prop="smethodName"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.smethodName"
                    placeholder="请输入写方法名"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item
                  label="文件名及路径"
                  size="default"
                  prop="filePath"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    type="textarea"
                    v-model="tableForm.filePath"
                    placeholder="请输入文件名及路径"
                  />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </div>
      </Dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import DataTable from "@/components/tableTemp/index.vue";
import Minheader from "@/components/minheader/index.vue";
import Dialog from "@/components/dialog/index.vue";
import { Query, GeneralDataReception } from "@/api/webApi";
import { ElMessage } from "element-plus";
const formRules = useElement().formRules;
const page = ref<number>(0); //分页参数
const dataContent = ref<object>({});
const noMore = ref<Boolean>(false);
const rowTitle = ref<String>("");
const tableCols = ref([]); //表头数据
const serviceId = ref<String>("");
const tableObj = ref({}); //增删改数据缓存
const flag = ref<Boolean>(false); //弹窗开关
const type = ref<String>(""); //判断是否删除
const msgTitle = ref<String>("新增协议管理"); //弹窗标题
const tableColsCopys = reactive<Object>({}); //弹窗
const tableForm = reactive({
  protocolID: "",
  protocolName: "",
  protocolType: "",
  filePath: "",
  className: "",
  rmethodName: "",
  smethodName: "",
  event: "",
}); //弹窗内容
//列表
const tableData = ref([]);
//表头
const state = reactive({
  list: [
    { label: "协议名称", key: "name" },
    { label: "类名", key: "china" },
    { label: "读方法名", key: "englin" },
    { label: "写方法名", key: "two" },
    { label: "文件名及路径", key: "three" },
  ],
  listLoading: true,
});
const tableBtnGroup = ref([
  {
    name: "编辑",
    className: "editBtn",
    param: 2,
    is: "arotocol_Editing",
  },
  {
    name: "删除",
    className: "delBtn",
    param: 3,
    is: "agreement_deletion",
  },
]);
//新增
const addForm = () => {
  msgTitle.value = "新增协议管理";
  flag.value = true;
  type.value = "";
  tableForm.event = 1;
};
//取消
const resetForm = () => {
  protocolManagement.value?.resetFields()
  flag.value = false;
  // tableForm.protocolID = "";
  // tableForm.protocolName = "";
  // tableForm.protocolType = "";
  // tableForm.filePath = "";
  // tableForm.className = "";
  // tableForm.rmethodName = "";
  // tableForm.smethodName = "";
};
//编辑-删除
const btnClick = (row, index, param) => {
  if (param === 2) {
    msgTitle.value = "编辑协议管理";
    flag.value = true;
    type.value = "";
    tableForm.event = 2;
    tableForm.protocolID = index.protocolID;
    tableForm.protocolName = index.protocolName;
    tableForm.protocolType = index.protocolType;
    tableForm.filePath = index.filePath;
    tableForm.className = index.className;
    tableForm.rmethodName = index.rmethodName;
    tableForm.smethodName = index.smethodName;
  } else if (param === 3) {
    msgTitle.value = "删除协议管理";
    flag.value = true;
    type.value = "del";
    tableForm.event = 3;
    tableForm.protocolID = index.protocolID;
    tableForm.protocolName = index.protocolName;
    tableForm.protocolType = index.protocolType;
    tableForm.filePath = index.filePath;
    tableForm.className = index.className;
    tableForm.rmethodName = index.rmethodName;
    tableForm.smethodName = index.smethodName;
  } else if (param === 4) {
  }
};
//删除
const eleDialog = () => {
  msgTitle.value = "删除协议管理";
  flag.value = true;
  type.value = "del";
};
const delRemove = () => {
  tableForm.event = 3;
  generalDataReception(tableForm);
};
//删除
const delRest = () => {
  flag.value = false;
};
//获取表格数据
const getQuery = async () => {
  try {
    const { code, returnData } = await Query({
      id: DATACONTENT_ID.sysProtoTabId,
      needPage: ++page.value,
      dataContent: Object.values(dataContent.value),
    });
    if (code === "0") {
      if (returnData.listValues.length === 0) {
        page.value--;
        noMore.value = true;
      }
      const titleColumn = returnData.columnSet.find(
        (item) => item.needShow === 1
      );
      if (titleColumn) {
        rowTitle.value = titleColumn.columnName;
      }
      tableData.value.push(...returnData.listValues);
      tableCols.value = returnData.columnSet;
      tableCols.value.forEach((element) => {
        element.label = element.columnLabel;
        element.key = element.columnName;
        // if (element.columnName === "queryTemplate") {
        //   element.width = "300px";
        // }
      });
      serviceId.value = returnData.submitID;
    } else {
      page.value--;
    }
  } catch (error) {
    page.value--;
  }
};
//确认提交
const protocolManagement: any = ref(null);
const submitForm = () => {
  protocolManagement.value.validate((valid: any) => {
    if (valid) {
      generalDataReception(tableForm);
    } else {
      return false;
    }
  });
};
const resetTable = () => {
  page.value = 0;
  noMore.value = false;
  tableData.value = [];
};

const btnAuthMap = [, 'agreement_addition', 'arotocol_Editing', 'agreement_deletion']
//新增-编辑-删除
const generalDataReception = async (data) => {
  try {
    data = {
      ...data,
    };
    const { code } = await GeneralDataReception({
      serviceId: serviceId.value,
      dataContent: JSON.stringify(data),
      btnAuth: btnAuthMap[data.event],
    });
    if (code == 0) {
      ElMessage.success(`操作成功`);
      // this.$message.success("操作成功");
      resetTable();
      getQuery();
      resetForm();
      flag.value = false;
      // rmFlag.value = false;
      tableObj.value = {};
      // this.$router.go(0);
    } else {
      ElMessage.error(`操作失败`);
      // this.$message.error("操作失败");
      // this.flag = false;
      // this.rmFlag = false;
      tableObj.value = {};
      resetForm();
    }
  } catch (error) {
    flag.value = false;
    //  rmFlag.value = false;
    tableObj.value = {};
    resetForm();
  }
};
getQuery();
</script>
<style lang="scss" scoped>
::v-deep .el-form-item__label {
  width: 110px;
}
</style>
